﻿function signData(bytes, keyindex) {
    byteProcessor.Clear();
    for (var i in bytes) {
        byteProcessor.Push(bytes[i]);
    }
    byteProcessor.Sign(keyindex);
    var signature = [];
    for (var i = 0; i < byteProcessor.Length() ; i++) {
        signature.push(byteProcessor.ValueAtIndex(i));
    }
    return signature;
}

function verifySignature(string, base64signature, keyindex) {
    byteProcessor.Clear();
    byteProcessor.LoadUTF8(string);
    return byteProcessor.VerifyBase64Signature(keyindex, base64signature);
}

function dataToBase64(bytes) {
    byteProcessor.Clear();
    for (var i in bytes) {
        byteProcessor.Push(bytes[i]);
    }
    return byteProcessor.AsBase64();
}

function base64ToData(string) {
    byteProcessor.LoadBase64(string);
    var data = [];
    for (var i = 0; i < byteProcessor.Length() ; i++) {
        data.push(byteProcessor.ValueAtIndex(i));
    }
    return data;
}

function uIntToData(uint, size) {
    byteProcessor.LoadUInt(uint, size);
    var data = [];
    for (var i = 0; i < byteProcessor.Length() ; i++) {
        data.push(byteProcessor.ValueAtIndex(i));
    }
    return data;
}

function parseJSON(json) {
    var data = eval('(' + json + ')');
    return data;
}

function getNode(nodeid) {
    return JSON.parse(getNodeInternal(nodeid));
}

function saveNode(node) {
    saveNodeInternal(JSON.stringify(node));
}
